## debputy 0.1.52

=== debian/changelog ===
debputy (0.1.52) unstable; urgency=medium

  * LSP/Lint:
    - Only remove the `X[CBS]-` prefixes from `d/control` field names when
      checking for known fields and duplicated fields.
    - When completing field names, properly account for the `X[CBS]-` prefix
      to avoid recommeding a field that would be considered a duplicate.
    - Add `X-Cargo-Crate` as a known field for `d/control`.
    - Add some `Homepage` related diagnostics for `d/control`. Check for
      insecure protocol and superflouous clutter in the URL/URI similar
      to lintian.

 -- Niels Thykier <niels@thykier.net>  Sun, 13 Oct 2024 12:48:44 +0000

debputy (0.1.51) unstable; urgency=medium

  * LSP/Lint:
    - Textual improvements to hover documentation and completion documentation.
      Thanks to Justin B Rye.
    - Allow exactly 80 chars per line in the extended description
      (Closes: debputy#122)
    - Warn about unknown top-levels in d/upstream/metadata. Previously, they
      were silently ignored unless they were typo-distance to a known field.
      This more closely matches the behavior of lintian.
    - Flag use of `Built-Using`/`Static-Built-Using` in arch:all packages.
      These fields are reserved for arch:any packages.
    - Provide better diagnostic for `>` and `<` version operators. Previously,
      they triggered a "parse error" diagnostic. Now they are identified as
      obsolete version operators with quick-fix suggestion to replace them
      with a non-obsolete counterpart.
    - Fix bug where known values were not always marked as obsolete
    - Fix assertion error on empty `Section:` field
    - Fix a case where completion docs would be on the form of `[TAG]: None`.
      This happened if there was no documentation for the field, but it was
      marked as obsolete or had a usage hint such as "RARE". The `: None` part
      is now omitted for this case leaving only the `[TAG]` part.
    - Mark `main/X` sections as replaced by `X`. The message for this diagnostic
      is a bit more aggressive than it should be but it triggers a warning and
      the proper quick-fix making it a net improvement.
    - Promote the correct section on completion if `debputy` can derive it. This
      is done by fiddling with the sort order, so it will now appear as the first
      completion option.

  [ Niels Thykier ]
  * Improve translation documentation
  * BuildSystemRule: Fix typo of `MESON_TESTTHREADS` and `--wrap-mode=nodownload`

  [ Justin B. Rye ]
  * Improve the hover documentation and completion documentation (those listed
    under `LSP/Lint` above).

 -- Niels Thykier <niels@thykier.net>  Fri, 04 Oct 2024 09:51:13 +0000

=== debian/control ===
Source: debputy
Section: devel
Priority: optional
Maintainer: Debputy Maintainers <debputy@packages.debian.org>
Uploaders:
 Niels Thykier <niels@thykier.net>,
Build-Depends:
 debhelper-compat (= 13),
#               man-db <pkg.debputy.ci>,
 dh-sequence-single-binary,
 hunspell-en-us <!nocheck>,
 python3-colored <!pkg.debputy.minimal>,
 python3-colorlog <!pkg.debputy.minimal>,
 python3-debian,
 python3-hunspell <!nocheck>,
 python3-levenshtein <pkg.debputy.ci>,
 python3-lsprotocol <!nocheck !pkg.debputy.bookworm-backports>,
 python3-polib <pkg.debputy.test-coverage pkg.debputy.developer-dependencies>,
 python3-pygls <!nocheck !pkg.debputy.minimal-tests !pkg.debputy.bookworm-backports>,
 python3-pytest <!nocheck>,
 python3-pytest-cov <pkg.debputy.test-coverage>,
 python3-ruyaml | python3-ruamel.yaml,
#               debputy-plugin-foo,
# The code was never checked with an older version than 3.11...
 python3:any (>= 3.11~),
 strip-nondeterminism <!nocheck>,
Rules-Requires-Root: no
X-Style: black
Standards-Version: 4.7.0
Homepage: https://salsa.debian.org/debian/debputy
Vcs-Git: https://salsa.debian.org/debian/debputy.git
Vcs-Browser: https://salsa.debian.org/debian/debputy

Package: dh-debputy
Architecture: all
Depends:
 debhelper,
 dwz <!pkg.debputy.minimal>,
 man-db <!pkg.debputy.minimal>,
# The colors dependencies are not necessary for debputy to work.
# However, to have coloring work, we need to use Depends because
# Recommends/Suggests are not resolved for builds and this should
# "just work" for users.
 python3-colored <!pkg.debputy.no-color>,
 python3-colorlog <!pkg.debputy.no-color>,
 python3-debian,
 python3-ruyaml | python3-ruamel.yaml,
# The code was never checked with an older version than 3.11...
 python3:any (>= 3.11~),
 strip-nondeterminism,
Recommends:
 python3-argcomplete,
Suggests:
 debputy-lsp,
 hunspell-en-us,
 python3-hunspell,
 python3-junit.xml,
 python3-levenshtein,
 python3-lsprotocol,
 python3-pygls,
Provides:
 debputy (= ${binary:Version}),
 debputy-plugin-gnome,
 debputy-plugin-grantlee,
 debputy-plugin-numpy3,
 debputy-plugin-perl-openssl,
 dh-sequence-debputy (= ${binary:Version}),
 dh-sequence-installdebputy (= ${binary:Version}),
 dh-sequence-zz-debputy (= ${binary:Version}),
 dh-sequence-zz-debputy-rrr (= ${binary:Version}),
Breaks:
# LSP/lint FP (deputy#120)
 debhelper (<= 13.19~),
Multi-Arch: foreign
Description: Manifest style Debian-based package builder (debhelper integration)
 Package builder that provides a declarative manifest for building Debian-based
 packages.
 .
 The debputy package builder aims to reduce cognitive load for the packager
 and provide better introspection to packagers, linters and the Debian
 janitor.
 .
 The debputy package also provides its own linting and editor support features
 via the debputy-lsp package that are aimed at as-you-type feedback.
 .
 This version integrates with the debhelper sequencer dh. Multiple integration
 modes are possible with dh. The most trivial integration mode is
 dh-sequence-zz-debputy-rrr, which is a mostly standard dh sequence with very
 few changes aimed entirely at removing the need for fakeroot when assembling
 the .deb.
 .
 For more information on all integration modes and what they do, please see
 https://salsa.debian.org/debian/debputy/-/blob/main/INTEGRATION-MODES.md

## debputy 0.1.54

=== debian/changelog ===
debputy (0.1.54) unstable; urgency=medium

  * LSP/Lint:
    - Reduce the chance of short dh config stems matching typos.
      This should prevent most false positives "typos" of the
      rarely used `.wm` file (used by `dh_installwm`) that would
      trigger on most other two letter extensions such as `.md`.
      (Closes: debputy#123)
    -  Exclude package names in spellchecking.
       Thanks to Matthias Geiger (@werdahias) (Closes: debputy#124)

  * build system: Automatically derive search dirs from build
    systems
  * Avoid using `debian/.debhelper` for dbgsym packages in full
    integration mode
  * Fix crash bug when combining two environments (could happen
    with some configurations in `debian/debputy.manifest`).
  * Fix crash bug with the `debputy lint` terminal report.

 -- Niels Thykier <niels@thykier.net>  Wed, 04 Dec 2024 21:22:33 +0000

debputy (0.1.53) unstable; urgency=medium

  * LSP/Lint:
    - Enable code actions (quick-fixes) for `d/patches/series`
    - Remove quick-fix for patch not using `.patch` extension. It
      would fail to rename the patch file, meaning it would cause
      the `series` files to be invalid.
    - Fix crash bug caused for (Static-)Built-Using
    - Replace crash bug with a pedantic lint diagnostic for Uploaders
    - Restrict (Static-)Built-Using to `=` version operator
    - Fix confused metadata about `XS-Ruby-Versions` and `X-DhRuby-Root`
    - Recognize `debian/changelog.dch` as a changelog when using filename
      based matching in the `debputy lsp server` mode.
    - Validate Debian version in `debian/changelog` is valid.
    - Downgrade `R³` with `Build-Driver diagnostic` to informational
      (down from a warning).
    - Remove work around in Homepage check for `debputy lint --auto-fix`.
      Previously, there was a guard preventing multiple overlapping
      diagnostics because it would crash `debputy lint --auto-fix`, since
      they both had a quick-fix. This has now been removed since
      `debputy lint --auto-fix` no longer crashes on this case.
    - Provide more validations on the Homepage field of `d/control`
    - Flag use of `|` relations in (Static-)Built-Using
    - Detect `dsfg` typo of `dfsg` in `d/changelog`

  * Provide a how-to guide for using `debputy`'s maintainer support
    features like `debputy lint`, `debputy reformat', and the
    LSP features. The document is provided in
    `/usr/share/doc/dh-debputy`.
  * For very trivial arch:all "docs-only" packages, `debputy` will
    now automatically set `Multi-Arch` to `foreign` if no
    `Multi-Arch` field is set for the package.  The package name
    must end with `-doc` or `-docs` for this change to apply. This
    is to avoid false positives with certain special cases like a
    `Multi-Arch: no` package depending on a `Multi-Arch: same` package
    to emulate `Multi-Arch: allowed` (which has its use-cases).
  * debputy lint: Cope better with overlapping edits for `--auto-fix`
  * debputy lint: Provide better error message on overlapping edit
    in case can still be triggered.

 -- Niels Thykier <niels@thykier.net>  Sat, 09 Nov 2024 14:42:17 +0000

## debputy 0.1.56

=== debian/changelog ===
debputy (0.1.56) unstable; urgency=medium

  * LSP/Lint: Check for trailing separator in `Maintainer` field.
    (see #1089649)
  * Tweak docs and make bug tracker URLs available on `debputy --help`
  * Fix regex value validation to use the correct interpreter for the
    field.

 -- Niels Thykier <niels@thykier.net>  Fri, 13 Dec 2024 14:13:42 +0000

debputy (0.1.55) unstable; urgency=medium

  * LSP/Lint:
   - Fix crash when no `Source` field was present in `d/control`
   - Use more authoritative references for some diagnostics.  Many
     `debputy` related issues are now correctly reported `Policy X` issues
     instead.
   - Fix typo of `X-Python3-Version`. Thanks
     Colin Watson <cjwatson@debian.org>.

  [ Niels Thykier ]
  * debputy lint: No longer correct spelling mistakes via `--auto-fix`.
    The spell checker had too many false positives, so these are now
    no longer candidates for automatic non-interactive fixing.
  * debputy lint: Include source/authority reference in the diagnostic
    when reporting an issue.

  [ Colin Watson ]
  * Fix `X-Pyton3-Version` typo when reporting `X-Python-Version` as
    as obsolete.

 -- Niels Thykier <niels@thykier.net>  Thu, 12 Dec 2024 17:44:27 +0000

## debputy 0.1.57~bpo12+1

=== debian/changelog ===
debputy (0.1.57~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.
  * Restore autopkgtests now that the relevant dependencies
    are present in -backports.
  * Remaining delta compared to testing:
    - Remove two optional build-dependencies. They are present
      in -backports now but the CI is using stable and
      therefore fails. The relevant dependencies are currently
      1:1 with testing and the CI has working tests for them
      in sid/testing.

 -- Niels Thykier <niels@thykier.net>  Thu, 19 Dec 2024 07:16:06 +0000

debputy (0.1.57) unstable; urgency=medium

  * LSP/Lint:
    - Fix crash/exception on using fields in the wrong stanza of
      `debian/control`.
    - Fix crash/exception on having obsolete fields in deb822 files.
    - Demote "Non-canonical spelling" of field name to `pedantic`
      (LSP `hint`) from `informational`.
    - Improve the hover docs for the `Multi-Arch` field and its
      values. Thanks to Justin B Rye.

  [ Niels Thykier ]
  * Add `.gitignore` to dest directories created when an upstream
    build system creates it to ensure it does not appear in the
    `git status` output. This is safe, since `debputy` always ignores
    `.gitignore` by default in binary packages for any glob/recursive
    matching.
  * Remove `exec` bit from files in `usr/share/themes` when building
    packages.
  * debputy lsp server: Add `--force-locale` option. This can be
    used to ensure that `debputy lsp server` always uses the given
    locale code for translations. This will ignore any locale code
    provided by the editor (if it provides one at all) as well as
    any OS/environ locale setting (that is, LC_ALL et al. is
    ignored). Since there are no translations, so it is not very
    useful immediately.

  [ Justin B Rye ]
  * More textual reviews from d-l10n-english

 -- Niels Thykier <niels@thykier.net>  Mon, 16 Dec 2024 09:51:33 +0000

## debputy 0.1.58

=== debian/changelog ===
debputy (0.1.58) unstable; urgency=medium

  * debputy reformat: Adopt `wrap-and-sort`'s latest package
    sorting changes. Thanks to Otto Kekäläinen <otto@debian.org>
    (Closes: debputy#127)

 -- Niels Thykier <niels@thykier.net>  Sun, 29 Dec 2024 13:42:44 +0000

## debputy 0.1.59

=== debian/changelog ===
debputy (0.1.59) unstable; urgency=medium

  * LSP/Lint:
    - Replace `XB-Important: yes` with `Protected: yes`
    - Remove `X-Python-Version` rather than replacing it with
      `X-Python3-Version`
    - Correct spelling of `XB-Ruby-Versions` for Package
      stanzas
  * debputy.pod: Improve the man page documentation a bit

 -- Niels Thykier <niels@thykier.net>  Thu, 02 Jan 2025 20:24:49 +0000

## debputy 0.1.61

=== debian/changelog ===
debputy (0.1.61) unstable; urgency=medium

  * LSP/Lint:
    - Fix crash on some YAML errors and fix off-by-one in error range.
    - Fix false positive "too short synopsis" with `${source:Synopsis}`
    - Document `${source:Synopsis}` and `{source:Extended-Description}`
      substvars.

  [ Andrea Pappacoda ]
  * cmake: pass BUILD_TESTING=OFF when nocheck option is active
  * meson: pass --prefix=/usr to configure and cd to builddir in install
    command.

  [ Niels Thykier ]
  * debputy: Fix crash bug with certain glob patterns.
    Thanks to Andrea Pappacoda <andrea@pappacoda.it> for reporting the
    issue. (Closes: #1093009)
  * debputy reformat: Also react to SALSA_CI_ENABLE_WRAP_AND_SORT.
    It is not documented as the official way to do it, but some
    people use it.

 -- Niels Thykier <niels@thykier.net>  Tue, 14 Jan 2025 19:57:40 +0000

debputy (0.1.60.1) unstable; urgency=medium

  [ Andrea Pappacoda ]
  * cmake: fix lstrip of CFLAGS and CPPFLAGS concatenation.
    (Closes: #1092877)

 -- Niels Thykier <niels@thykier.net>  Sun, 12 Jan 2025 23:30:37 +0000

debputy (0.1.60) unstable; urgency=medium

  * LSP/Lint:
    - Provide doc URIs in substvars hover docs.
    - Make parts of the substvars description translatable.

  * debputy editor-config: Mention `vim-python3` requirement for
    `vim-youcompleteme`. That is, `vim-youcompleteme` needs to be
    be used with a `vim` that provides `vim-python3` such as
    `vim-nox`.
  * debputy: Make `DEBPUTY_DEBUG=1` equal to `--debug` and document it
    as such.  Thanks to Andrea Pappacoda <andrea@pappacoda.it>
  * debputy: Introduce trace logging for internal use. This reduces
    some commonly "noise" such as "context switches" for plugins,
    which is likely not going to be relevant in most situations.
  * debputy: Fix `NoneType` crash in `relative_from_builddir_to_source`
    Thanks to Andrea Pappacoda <andrea@pappacoda.it>
    (Closes: #1092794)
  * cmake build system: Correct definition of `pkg-config`. It now
    uses full path to the `pkg-config` binary like `debhelper`.
  * Fix inverted boolean logic that caused wrong environment
    for the cmake and the meson build systems.

 -- Niels Thykier <niels@thykier.net>  Sun, 12 Jan 2025 15:15:56 +0000

## debputy 0.1.62

=== debian/changelog ===
debputy (0.1.62) unstable; urgency=medium

  * Improve on-line documentation (`debputy plugin show p-m-r` or
    hover docs in the LSP module for `debputy.manifest` file):
    - Make conditional rules order deterministic. Previously, parts
      were hash-order dependent and could change order between each
      rendering.
    - Fix incorrect reference to manifest variables. Previously,
      the rendering incorrectly used `{FOO}` when it should have
      shown `{{FOO}}`.
    - Fix link anchor to a section.
    - Mention required integration mode for features. Note this
      change only lists the recorded integration mode tags in
      the documentation. However, there may still be some features
      that are still incorreclty tagged as "applicable in all
      integration modes".
    - Improve the docs for build systems and related attributes.
  * MANIFEST-FORMAT.md: Generate a lot of the documentation from
    `debputy` "on-line" docs rendering. This implies changed
    formatting and layout. But also, the MANIFEST-FORMAT.md and
    the online docs are now much more consistent, since most of
    the docs have a single source of truth.
  * MANIFEST-FORMAT.md: Document new build system rules and
    environments. Thanks to Andrea Pappacoda <andrea@pappacoda.it>
    (Closes: debputy#130)
  * INTEGRATION-MODES.md: Tweak some wording
  * debputy: Better error message on missing commands during builds
  * debputy: Fix false-positive "path was not installed" with `-B`/`-A`
    builds. (Closes: debputy#132)
  * debputy: Avoid double-initialization of ENV for auto-detected
    builds. This was just slow (invoked `dpkg-buildflags` twice) and
    provided no benefits.
  * meson: Make `--test` verbose by default to match upcoming
    debhelper update (disabled in `terse` builds).

 -- Niels Thykier <niels@thykier.net>  Fri, 17 Jan 2025 20:21:22 +0000

## debputy 0.1.63~bpo12+1

=== debian/changelog ===
debputy (0.1.63~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.
  * Remaining delta compared to testing:
    - Remove two optional build-dependencies. They are present
      in -backports now but the CI is using stable and
      therefore fails. The relevant dependencies are currently
      1:1 with testing and the CI has working tests for them
      in sid/testing.

 -- Niels Thykier <niels@thykier.net>  Mon, 27 Jan 2025 08:47:33 +0000

debputy (0.1.63) unstable; urgency=medium

  * LSP/Lint:
    - Fix crash on more invalid YAML files or manifests
    - Support completion detail for `d/debputy.manifest` completions.
      Only select cases have this feature, so you may still see
      completions without a one-line detail about what it is.

  * debputy: Refine the stack-trace shown on plugin initialization errors
  * debputy: Correct logic for passing files to `strip-nondeterminism`
  * debputy reformat: Skip sorting of fields when it would drop a comment
    (Closes: debputy#112)
  * debputy: Fix crash on install rules for packages not being built.
    The change for debputy#132 introduced a regression, where packages not
    being built (such as `arch:all` packages during a `-B` build) could
    trigger a crash when a single install rule matched two or more "root"
    directories that shared a common subdirectory (such as `examples/*`
    with `examples/a/data` and `examples/b/data`).
    Thanks to Abou Al Montacir <abou.almontacir@sfr.fr>
    (Closes: #1093680)
  * debputy: Stop passing `-v` to `strip-nondeterminism`

 -- Niels Thykier <niels@thykier.net>  Tue, 21 Jan 2025 19:08:10 +0000

=== debian/control ===
--- 
+++ 
@@ -14,9 +14,7 @@
  python3-debian,
  python3-hunspell <!nocheck>,
  python3-levenshtein <pkg.debputy.ci>,
- python3-lsprotocol <!nocheck !pkg.debputy.bookworm-backports>,
  python3-polib <pkg.debputy.test-coverage pkg.debputy.developer-dependencies>,
- python3-pygls <!nocheck !pkg.debputy.minimal-tests !pkg.debputy.bookworm-backports>,
  python3-pytest <!nocheck>,
  python3-pytest-cov <pkg.debputy.test-coverage>,
  python3-ruyaml | python3-ruamel.yaml,

## debputy 0.1.65~bpo12+1

=== debian/changelog ===
debputy (0.1.65~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.
  * Remaining delta compared to testing:
    - Remove two optional build-dependencies. They are present
      in -backports now but the CI is using stable and
      therefore fails. The relevant dependencies are currently
      1:1 with testing and the CI has working tests for them
      in sid/testing.

 -- Niels Thykier <niels@thykier.net>  Mon, 10 Mar 2025 22:25:00 +0000

debputy (0.1.65) unstable; urgency=medium

  * LSP/Lint:
    - Skip hover/completion inside Deb822 comments. Generally.
      it ended up triggering for the next content line instead.
    - Improve hover docs for packages when viewed in some editors
      (concretely `kate`). The previous docs worked
      specifically with how `emacs` rendered its Markdown docs.
      However, `emacs`'s method does not reformat text blocks,
      so it does not seem like it was the best editor to test with.
    - Tweak Inlay hint for inherited Deb822 values to make it
      prettier in `kate` and other editors. The previous rendering
      relied on editors to "gracefully" cope with newlines in the
      Inlay Hint label. The specs says nothing about the editor
      should react to those, so it was safer to avoid them.
    - When emitting a code action to the editor, do not provide
      `TextEdit`s in the "old" and the "new" format. Some editors
      (Concretely, `kate`) apply both with exciting but unhelpful
      results. The spec seems implies that the server is at fault
      if this happens, so the bug was probably `debputy`'s to
      begin with.
    - Track diagnostics with full metadata internally in `debputy`.
      This enables quickfixes in editors that either do not inform
      `debputy` of related diagnostics when requesting code actions
      (`kate`) or when the editor does not support the `data`
      attribute in the diagnostic (which the spec allows the editor
      to "not do"). Either way, more editors should now see
      quickfixes with `debputy`'s diagnostics.
    - Fix incorrect duplication warning for `foo` vs. `foo:native`
      when validating package relationships. Thanks to
      Otto Kekäläinen <otto@debian.org> for reporting this problem
      with the new check introduced in 0.1.64.

 -- Niels Thykier <niels@thykier.net>  Sat, 08 Mar 2025 22:14:52 +0000

debputy (0.1.64) unstable; urgency=medium

  * LSP/Lint:
    - Detect simple cases of duplicate relatations.
      Thanks to Matthias Geiger <werdahias@debian.org>
      (Closes: debputy#134)

  [ Vincent Blut ]
  * debputy: Fix command example to show editor snippets
  * debputy.pod: Fix typo in man page
  * deputy lsp editor-config: Fix missing '}' in filetype mapping
    instructions for neovim

  [ Niels Thykier ]
  * Add an rtupdate script to ensure byte-compilation happens on
    python interpreter update.
    Thanks to Stefano Rivera <stefanor@debian.org> (Closes: #1099543)
  * debputy lint: Print the related context when provided
  * Fix type error/crash with certain diagnostics

 -- Niels Thykier <niels@thykier.net>  Fri, 07 Mar 2025 16:32:31 +0000

## debputy 0.1.66

=== debian/changelog ===
debputy (0.1.66) unstable; urgency=medium

  * LSP/Lint:
    - Ensure `dh_assistant` is run from the current source package root.
      This could cause false positive and false negative diagnostics
      with the LSP mode (`debputy lint` was unaffected).
    - Properly detect unused debhelper config files under `full`
      integration.
    - Flag substvars as `macro` in the semantic tokens. Editors that use
      semantic tokens for highlighting can now highlight substvars distinctly
      from the surrounding text.
    - Emit comment tokens for comments inside unknown fields in the semantic
      token feature. For editors that use semantic tokens for syntax
      highlighting, these inline value comments are now properly highlighted.
    - Consider relations with arch or build profile restrictions as complex
      to reduce false positives (at the cost of false negative) for duplicated
      relations.
    - Do not consider hidden files as patches. This avoids triggering
      "Unused Patch" diagnostics for `debian/patches/series" for editor
      swap files that were hidden but did not match the previous known
      patterns.
    - Make severanl of the LSP features (diagnostics, semantic tokens, and
      inlay hints) asynchronous. These requests will no longer stall
      `debputy` until responded. This will make `debputy` seem more
      responsive on larger files like `linux` (its generated `d/control`
      is 0.5 MB).
      Note that other requests (completion, hover) are still synchronous
      and will block other requests (including ongoing asynchronous ones).

  * debputy lsp server: Correctly track partial diagnostic reports
    internally. The previous version did not emit partial diagnostic
    reports, so this bug could not trigger any unintended behavio (
    but probably would have down the line).

 -- Niels Thykier <niels@thykier.net>  Mon, 10 Mar 2025 22:11:30 +0000

## debputy 0.1.67~bpo12+1

=== debian/changelog ===
debputy (0.1.67~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.
  * Remaining delta compared to testing:
    - Remove two optional build-dependencies. They are present
      in -backports now but the CI is using stable and
      therefore fails. The relevant dependencies are currently
      1:1 with testing and the CI has working tests for them
      in sid/testing.

 -- Niels Thykier <niels@thykier.net>  Mon, 17 Mar 2025 16:36:13 +0000

debputy (0.1.67) unstable; urgency=medium

  * debputy: Flush command output. When printing what build system
    command is being run, flush the command so it appears before
    its output to reduce confusion.
    Thanks to Helmut Grohne <helmut@subdivi.de>
  * cmake: Add missing -DCMAKE_INSTALL_LIBDIR to match what
    `debhelper` does. This fixes a problem with cross-builds, but
    native builds seems unaffected. Presumably, the Debian `cmake`
    has a built-in default to apply the correct value here.
    Thanks to Helmut Grohne <helmut@subdivi.de>
  * debputy: Fix crash on creating dbgsym packages and other cases,
    where `debputy` would include a symlink in the package without
    a FS backed symlink behind it.
    Thanks to Andrea Pappacoda <tachi@debian.org> (Closes: #1100154)

 -- Niels Thykier <niels@thykier.net>  Thu, 13 Mar 2025 16:50:42 +0000

## debputy 0.1.67

=== Makefile ===
#!/usr/bin/make -f

DEBPUTY_INSTALLED_ROOT_DIR=/usr/share/dh-debputy
DEBPUTY_INSTALLED_PLUGIN_ROOT_DIR=/usr/share/debputy/

# Nothing to do by default
all:

check:
	py.test -v

install:
	install -m0755 -d \
	    $(DESTDIR)/usr/bin \
	    $(DESTDIR)/$(DEBPUTY_INSTALLED_ROOT_DIR) \
	    $(DESTDIR)/$(DEBPUTY_INSTALLED_PLUGIN_ROOT_DIR)/debputy \
	    $(DESTDIR)/usr/share/perl5/Debian/Debhelper/Sequence \
	    $(DESTDIR)/usr/share/perl5/Dpkg/BuildDriver \
	    $(DESTDIR)/usr/share/man/man1
	install -m0755 -t $(DESTDIR)/usr/bin dh_debputy dh_installdebputy assets/debputy
	install -m0755 -t $(DESTDIR)/$(DEBPUTY_INSTALLED_ROOT_DIR) deb_packer.py deb_materialization.py
	install -m0644 -t $(DESTDIR)/usr/share/perl5/Debian/Debhelper/Sequence lib/Debian/Debhelper/Sequence/*.pm
	install -m0644 -t $(DESTDIR)/usr/share/perl5/Dpkg/BuildDriver lib/Dpkg/BuildDriver/*.pm
	cp -a --reflink=auto src/debputy $(DESTDIR)/$(DEBPUTY_INSTALLED_ROOT_DIR)
	cp -a --reflink=auto debputy $(DESTDIR)/$(DEBPUTY_INSTALLED_PLUGIN_ROOT_DIR)
	sed -i "s/^__version__ =.*/__version__ = '$$(dpkg-parsechangelog -SVersion)'/; s/^__release_commit__ =.*/__release_commit__ = 'N\\/A'/;" \
	   $(DESTDIR)/$(DEBPUTY_INSTALLED_ROOT_DIR)/debputy/version.py
	perl -p -i -e 's{^DEBPUTY_ROOT_DIR =.*}{DEBPUTY_ROOT_DIR = pathlib.Path("$(DEBPUTY_INSTALLED_ROOT_DIR)")};' \
	   $(DESTDIR)/$(DEBPUTY_INSTALLED_ROOT_DIR)/debputy/__init__.py
	perl -p -i -e 's{^DEBPUTY_PLUGIN_ROOT_DIR =.*}{DEBPUTY_PLUGIN_ROOT_DIR = pathlib.Path("$(DEBPUTY_INSTALLED_PLUGIN_ROOT_DIR)")};' \
	   $(DESTDIR)/$(DEBPUTY_INSTALLED_ROOT_DIR)/debputy/__init__.py
	find $(DESTDIR)/usr/share/dh-debputy -type d -name '__pycache__' -exec rm -fr {} +
	pod2man --utf8 --section=1 --name="debputy" -c "The debputy Debian packager helper stack" debputy.pod \
	   $(DESTDIR)/usr/share/man/man1/debputy.1
	pod2man --utf8 --section=1 --name="dh_debputy" -c "The debputy Debian packager helper stack" dh_debputy \
	   $(DESTDIR)/usr/share/man/man1/dh_debputy.1
	pod2man --utf8 --section=1 --name="dh_installdebputy" -c "The debputy Debian packager helper stack" dh_installdebputy \
	   $(DESTDIR)/usr/share/man/man1/dh_installdebputy.1
	devutils/install-translations
	chmod -R u=rwX,go=rX \
	    $(DESTDIR)/$(DEBPUTY_INSTALLED_ROOT_DIR)/debputy \
	    $(DESTDIR)/$(DEBPUTY_INSTALLED_PLUGIN_ROOT_DIR)/debputy

=== debian/control ===
--- 
+++ 
@@ -14,8 +14,11 @@
  python3-debian,
  python3-hunspell <!nocheck>,
  python3-levenshtein <pkg.debputy.ci>,
+ python3-lsprotocol <!nocheck !pkg.debputy.bookworm-backports>,
  python3-polib <pkg.debputy.test-coverage pkg.debputy.developer-dependencies>,
+ python3-pygls <!nocheck !pkg.debputy.minimal-tests !pkg.debputy.bookworm-backports>,
  python3-pytest <!nocheck>,
+ python3-pytest-asyncio <!nocheck>,
  python3-pytest-cov <pkg.debputy.test-coverage>,
  python3-ruyaml | python3-ruamel.yaml,
 #               debputy-plugin-foo,

## debputy 0.1.67.1~bpo12+1

=== debian/changelog ===
debputy (0.1.67.1~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.
  * Remaining delta compared to testing:
    - Remove two optional build-dependencies. They are present
      in -backports now but the CI is using stable and
      therefore fails. The relevant dependencies are currently
      1:1 with testing and the CI has working tests for them
      in sid/testing.

 -- Niels Thykier <niels@thykier.net>  Mon, 26 May 2025 14:58:17 +0000

debputy (0.1.67.1) unstable; urgency=medium

  [ Colin Watson ]
  * Fix spelling of Maintainer field error in diagnostic
    message.

  [ Niels Thykier ]
  * debputy: Fix crash with `debputy lint --auto-fix`

 -- Niels Thykier <niels@thykier.net>  Mon, 21 Apr 2025 18:00:45 +0000

=== debian/control ===
--- 
+++ 
@@ -14,9 +14,7 @@
  python3-debian,
  python3-hunspell <!nocheck>,
  python3-levenshtein <pkg.debputy.ci>,
- python3-lsprotocol <!nocheck !pkg.debputy.bookworm-backports>,
  python3-polib <pkg.debputy.test-coverage pkg.debputy.developer-dependencies>,
- python3-pygls <!nocheck !pkg.debputy.minimal-tests !pkg.debputy.bookworm-backports>,
  python3-pytest <!nocheck>,
  python3-pytest-asyncio <!nocheck>,
  python3-pytest-cov <pkg.debputy.test-coverage>,

## debputy 0.1.67.1

=== debian/rules ===
#!/usr/bin/make -f

export DEBPUTY_CMD=$(CURDIR)/debputy.sh

%:
	$(DEBPUTY_CMD) --plugin self-hosting-plugins/debputy-self-hosting.json internal-command dpkg-build-driver-run-task $@

## debputy 0.1.68

=== debian/changelog ===
debputy (0.1.68) experimental; urgency=medium

  * LSP/Reformat:
    - The `black` style now rewrites field names to use the canonical
      spelling of fields for fields where `debputy` knows the canonical
      name. Unknown fields remain in their current case/spelling.

  * LSP/Lint:
    - Improve performance of semantic tokens request (LSP only), diagnostics
      (both LSP and `debputy lint` side), and inlay hints (LSP only).
    - Add more sematic tokens for relationship fields
    - Conditionally use `TextDocumentEdit` if the LSP client supports them.
      (bring us one step closer to supporting quick fixes that renames files)
    - Use plugin data for known packaging files to prevent false-positive
      prevention. This also avoids double maintenance of known packaging
      files.
    - Fix crash on typo of key in YAML based files
    - Recognize `.rst` and `.config` as non-typo extensions for files in
      the `debian/` directory.
    - Fix problem where raw type was shown instead of real type in the
      hover docs.
    - Improve YAML value validation to cover more cases. There are still
      constructs where the validation should catch errors but where the
      diagnostic code does not yet have a case for it.
    - Fix quick fix for `manifest-version` value not being quoted. That is,
      using the quick fix caused a diagnostic error. To add insult to injury,
      said error would have a quick fix that did not fix the error.
    - Hide integration mode text from hover docs in d/upstream/metadata
    - Fix crash/exception on completion in completely empty YAML files
    - Make it configurable if syntactical comments are spellchecked
      (Closes: debputy#125)
    - Provide completion suggestions in more cases for YAML based formats
    - Suggest dpkg makefiles as completion in d/rules after `include`
    - Support plugin provided manifest variables in completion + hover in
      `debputy.manifest`.
    - Tweak diagnostic message for using hook targets for inactive dh
      commands.
    - Define two more known substvars in `d/control` by providing hover
      docs and completion suggestions for them.
    - Add `vim-debian` ID for `debian/tests/control` after they added the
      support for it this week in the mainline. Relevant editor config
      snippet examples have been updated.
    - Add more checks of the sign-off line in `d/changelog`
    - Improve completion of variables in `debputy.manifest`. Notably,
      it is now possible to complete them inside an incomplete quote
      (which is a common case for them, since they require quoting).

  * Manifest:
    - All `debputy` provided build systems now accept a `test-rule`
      attribute. It can be used to control when tests should be run
      or when tests should be non-fatal.
    - The definition of the `not` conditional has been corrected.
      It previously allowed an invalid form as well as the intended.
      The invalid form has now been removed.
    - The `for` attributes in build systems now support basic package
      selectors like `arch:all` in addition to plain package names.

  * Plugin API:
    - Add new preferred way for Python plugins to initialize

  * Add `debian/lrc.config` as a known Debian packaging file,
    which also means it is no longer a false positive for the typo
    detection of packaging files in the `debian/` directory.
    (Closes: debputy#135)
  * debputy: Provide clearer error on some types of invalid plugins
  * MANIFEST-FORMAT.md: Create a section on type mappings including
    a full listing of all type mappings provided by `debputy`.
  * Ensure generated MANIFEST-FORMAT.md always ends with a newline
  * MANIFEST-FORMAT.md: Use literal markup for "enum"-like values
  * Set HOME and XDG_RUNTIME_DIR during build similar to `debhelper`.
  * Refactor to ensure dest_dirs from build systems are computed in build env.
    This did not matter for any `debputy` provided build system, but will
    likely be relevant for some third party build systems down the line.
  * Build system: Cache output of `dpkg-buildflags` calls with same `DEB_*`
    env.
  * Fix problem where raw type was shown instead of real type in the static
    docs and in the CLI output for showing docs.
  * debputy: Be more lenient when parsing the LSP/lint config file
  * Support building basic LSP/lint-only version of `debputy` via hatchling
  * Bump Standards-Versions to 4.7.2
  * Enable support for `debian/package.udev` files again
  * migrate-from-dh: Recognise `zz-debputy-rrr` as known
  * debputy: Add a `Commands` field to `.deb` packages (but not `.udeb`)
    for packages that contains binaries in path to `command-not-found`
    (see #638517).
  * debputy: Work around `debhelper` or old `libjson-pp-perl` bug. This
    could cause `debputy` emit false positives for most of the files
    in the `debian/` directory. The problem can be avoided by installing
    either this version of `debputy`, `debhelper/13.25`, or
    `libjson-pp-perl/4.16000-1`. The `trixie` version of `perl` comes
    with the relevant version of `libjson-pp-perl` implied, which is
    why this problem was not reproducible in `trixie`.

 -- Niels Thykier <niels@thykier.net>  Tue, 15 Jul 2025 05:21:31 +0000

## debputy 0.1.69

=== debian/changelog ===
debputy (0.1.69) experimental; urgency=medium

  * LSP/Reformat:
    - Fix bug that could eat field comments when the
      field was reformatted.
      Thanks to Chris Hofstaedtler <zeha@debian.org>
      (Closes: debputy#140)
    - Fix crash bug caused by overlapping edits. The
      bug that caused overlapping edits was introduced
      in 0.1.68.

  * Fix LSP feature check for `spellchecking`. It checked
    the wrong import was present and therefore the answer
    did not reflect reality.
  * Disable `dwz` to match `debhelper`. The migration of
    `arch:any` packages now assumes compat 14 semantics
    for this reason.

 -- Niels Thykier <niels@thykier.net>  Sat, 19 Jul 2025 06:12:03 +0000

=== debian/control ===
--- 
+++ 
@@ -14,7 +14,9 @@
  python3-debian,
  python3-hunspell <!nocheck>,
  python3-levenshtein <pkg.debputy.ci>,
+ python3-lsprotocol <!nocheck !pkg.debputy.bookworm-backports>,
  python3-polib <pkg.debputy.test-coverage pkg.debputy.developer-dependencies>,
+ python3-pygls <!nocheck !pkg.debputy.minimal-tests !pkg.debputy.bookworm-backports>,
  python3-pytest <!nocheck>,
  python3-pytest-asyncio <!nocheck>,
  python3-pytest-cov <pkg.debputy.test-coverage>,
@@ -25,7 +27,7 @@
  strip-nondeterminism <!nocheck>,
 Rules-Requires-Root: no
 X-Style: black
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Homepage: https://salsa.debian.org/debian/debputy
 Vcs-Git: https://salsa.debian.org/debian/debputy.git
 Vcs-Browser: https://salsa.debian.org/debian/debputy

## debputy 0.1.70

=== debian/changelog ===
debputy (0.1.70) experimental; urgency=medium

  * LSP/Lint+Reformat:
    - More strict deb822 checks before activating features

  * LSP/Lint:
    - Initial support for version 5 `debian/watch` files
    - The `Priority` field now defaults to `optional`

  * LSP/Reformat:
    - Fix a limitation that prevented some automatic
      rewrites of fields into their canonical form.
      It was previously only observed with
      `XC-Package-Type` but it is more apparent with
      with the new `debian/watch` support.

  * debputy reformat: Accept `--write-style` option
  * debputy lsp server: Work around KDE#506664 to reduce
    the noise in LSP output.

 -- Niels Thykier <niels@thykier.net>  Mon, 28 Jul 2025 08:48:26 +0000

## debputy 0.1.71

=== debian/changelog ===
debputy (0.1.71) unstable; urgency=medium

  * Upload to unstable.

 -- Niels Thykier <niels@thykier.net>  Sun, 10 Aug 2025 06:55:29 +0000

## debputy 0.1.72

=== debian/changelog ===
debputy (0.1.72) unstable; urgency=medium

  * LSP/Lint:
    - Update `d/watch` metadata to match recent changes
    - Add check for `Format` using `https://` in `d/copyright`

  [ Niels Thykier ]
  * doc: Provide a reading guide for the lint + LSP features
  * d/control: Remove explicit `Priority` field

  [ Ananthu C V ]
  * debian-wordlist.dic: make the lsp recognize some of the rust world

 -- Niels Thykier <niels@thykier.net>  Tue, 19 Aug 2025 20:19:36 +0000

## debputy 0.1.73

=== debian/changelog ===
debputy (0.1.73) unstable; urgency=medium

  * migrate-from-dh:
    - Add support for common configuration of packages
      maintained in `git`. When `git` is detected,
      `--apply-changes` is now the default and the changes
      will be registered with `git`, so they are easier to
      commit or undo.
    - Add `dh-single-to-multi-binary` migration target, which
      can assist with migrating from a single-binary to a
      multi-binary source package with debhelper.
    - Add `dh-package-prefixed-config-files` migration target,
      which will add an explicit package prefix to all
      recognizable debhelper config files. The `debhelper`
      framework requires this for multi-binary source packages
      as of compat 14+. This migration is a subset of the
      `dh-single-to-multi-binary` migration.

  [ Ananthu C V ]
  * debian-wordlist.dic: add more tooling a programming language
    related common jargon for Lint/LSP recognition

 -- Niels Thykier <niels@thykier.net>  Sun, 24 Aug 2025 07:53:59 +0000

## debputy 0.1.74.1

=== debian/changelog ===
debputy (0.1.74.1) unstable; urgency=medium

  * Include missing file

 -- Niels Thykier <niels@thykier.net>  Tue, 26 Aug 2025 18:54:21 +0000

debputy (0.1.74) unstable; urgency=medium

  * LSP/Lint:
    - Add `X-DH-Compat` as known `d/control` field
    - Document `debputy` and `debian-rules` build drivers

  * debputy: Speed start up time for some subcommands.
  * debputy: Avoid defaulting to `debhelper`'s `none` build system

 -- Niels Thykier <niels@thykier.net>  Tue, 26 Aug 2025 18:51:57 +0000

## debputy 0.1.75

=== debian/changelog ===
debputy (0.1.75) unstable; urgency=medium

  * Manifest:
    - Fix a bug where two keywords where parsed but ignored.
      The `installation-search-dirs` and the `conffile-management` keys
      under `packages.<PACKAGE>` would be full parsed, validated and
      then silently ignored due to a bug in `debputy`.
    - Add `remove-during-clean`. This is `debputy`'s answer to
      `debian/clean` from `dh_clean`.  Thanks to
      Paride Legovini <paride@debian.org> for reporting the missing
      feature.

  * migrate-from-dh:
    - Support migrating `d/clean` files to the new
      `remove-during-clean` feature.

 -- Niels Thykier <niels@thykier.net>  Sat, 30 Aug 2025 09:30:31 +0000

debputy (0.1.74.2) unstable; urgency=medium

  * LSP/Lint: Fix metadata mismatch where `X-DH-Compat` was a binary field

 -- Niels Thykier <niels@thykier.net>  Wed, 27 Aug 2025 16:33:53 +0000

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: debputy
 Section: devel
-Priority: optional
 Maintainer: Debputy Maintainers <debputy@packages.debian.org>
 Uploaders:
  Niels Thykier <niels@thykier.net>,

## debputy 0.1.76~bpo13+1

=== debian/changelog ===
debputy (0.1.76~bpo13+1) trixie-backports; urgency=medium

  * Rebuild for trixie-backports.

 -- Niels Thykier <niels@thykier.net>  Sat, 20 Sep 2025 17:21:33 +0000

debputy (0.1.76) unstable; urgency=medium

  * LSP/Lint:
    - Add `Version-Type` field metadata for `d/watch`

  * debputy: Ensure relationship substvars are inserted in stable
    order.

 -- Niels Thykier <niels@thykier.net>  Mon, 15 Sep 2025 18:08:21 +0000

=== debian/tests/control ===
Tests:
 debputy-py.test,
Restrictions:
 allow-stderr,
# debputy loads the libcap2 library directly for one of the tests
Depends:
 libcap2,
 python3-all,
 python3-lsprotocol,
 python3-pytest,
 @,

Tests:
 debputy-cli,
Restrictions:
 allow-stderr,
 superficial,
Depends:
 @,

Tests:
 debputy-cli-lint-lsp,
Restrictions:
 allow-stderr,
 superficial,
Depends:
 python3-lsprotocol,
 @,

Tests:
 debputy-cli-lsp,
Restrictions:
 allow-stderr,
 superficial,
Depends:
 python3-lsprotocol,
 python3-pygls,
 @,

## debputy 0.1.76~bpo13+2

=== debian/changelog ===
debputy (0.1.76~bpo13+2) trixie-backports; urgency=medium

  * Rebuild for trixie-backports.
  * Source-only upload

 -- Niels Thykier <niels@thykier.net>  Mon, 22 Sep 2025 05:32:39 +0000

## debputy 0.1.76ubuntu1

=== debian/changelog ===
debputy (0.1.76ubuntu1) questing; urgency=medium

  * Adapt compute_output_filename to know about variants.

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Wed, 08 Oct 2025 06:44:45 +1300

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,7 @@
 Source: debputy
 Section: devel
-Maintainer: Debputy Maintainers <debputy@packages.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debputy Maintainers <debputy@packages.debian.org>
 Uploaders:
  Niels Thykier <niels@thykier.net>,
 Build-Depends:

## debputy 0.1.77~bpo13+1

=== debian/changelog ===
debputy (0.1.77~bpo13+1) trixie-backports; urgency=medium

  * Rebuild for trixie-backports.

 -- Niels Thykier <niels@thykier.net>  Tue, 30 Sep 2025 16:42:30 +0000

debputy (0.1.77) unstable; urgency=medium

  * LSP/Lint:
    - Add support for new `uscan` templates

  * LSP/Reformat:
    - LSP/Reformat: Recognise `debian/gitlab-ci.yml`

  * migrate-from-dh:
   - Remove invalid min-compat check for dh-compat migrations
   - Cope better with `../foo` paths in `dh` config files.
     Either map to `debian/foo` or provide a better error
     message, when unsupported.

  * Plugin API:
    - Improve support for modern types

  * debputy: Use `difflib` rather than forking `diff -u` for diffs
  * debputy: Add support for `X-Doc-Main-Package`
  * debputy: fix potential crash (`NameError`) under `migrate-from-dh`

 -- Niels Thykier <niels@thykier.net>  Fri, 26 Sep 2025 18:27:40 +0000

## debputy 0.1.78~bpo13%2B1

=== debian/changelog ===
debputy (0.1.78~bpo13+1) trixie-backports; urgency=medium

  * Rebuild for trixie-backports.

 -- Niels Thykier <niels@thykier.net>  Wed, 15 Oct 2025 18:54:37 +0000

debputy (0.1.78) unstable; urgency=medium

  * LSP/Lint:
    - Add check of canonical spelling of maintainer names.
    - Provide bug links for `d/changelog` for the most
      recent bugs.

 -- Niels Thykier <niels@thykier.net>  Sun, 12 Oct 2025 11:44:43 +0000

## debputy 0.1.78

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,6 @@
 Source: debputy
 Section: devel
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debputy Maintainers <debputy@packages.debian.org>
+Maintainer: Debputy Maintainers <debputy@packages.debian.org>
 Uploaders:
  Niels Thykier <niels@thykier.net>,
 Build-Depends:
@@ -14,9 +13,9 @@
  python3-debian,
  python3-hunspell <!nocheck>,
  python3-levenshtein <pkg.debputy.ci>,
- python3-lsprotocol <!nocheck !pkg.debputy.bookworm-backports>,
+ python3-lsprotocol <!nocheck>,
  python3-polib <pkg.debputy.test-coverage pkg.debputy.developer-dependencies>,
- python3-pygls <!nocheck !pkg.debputy.minimal-tests !pkg.debputy.bookworm-backports>,
+ python3-pygls <!nocheck !pkg.debputy.minimal-tests>,
  python3-pytest <!nocheck>,
  python3-pytest-asyncio <!nocheck>,
  python3-pytest-cov <pkg.debputy.test-coverage>,

## debputy 0.1.79

=== debian/changelog ===
debputy (0.1.79) unstable; urgency=medium

  * Backwards Incompatibility:
    - Install `debian/pkg.modprobe` files under `/usr/lib/modprobe.d`.
      No packages using `debputy` in Debian used this feature yet,
      so the change was done without migration. If you migrate a
      package using `debian/pkg.modprobe`, please consider adding
      `dh-debputy (>= 0.1.79~)` as Build-Dependency to ensure there
      are no surprises with backports (etc.).

  * Manifest changes:
    - Add `built-using` and `static-built-using` keywords to enable
      `debputy` to generate `Built-Using` and `Static-Built-Using`
      for you. This replaces the `dh-sequence-builtusing` when
      using either `full` or `dh-sequence-zz-debputy` integration
      mode.  (Closes: #1121339)

  * migrate-from-dh:
    - Detect and provide manual instructions for migrating from
      `dh-builtusing` in `dh-sequence-zz-debputy` or `full`
      integration mode.

  * Plugin API:
    - Manifest detectors can now access some of the pluggable
      manifest rules via the context.

  [ Michael Hudson-Doyle ]
  * debputy: Support Ubuntu's `Architecture-Variant` when deciding
    the output file name for binary packages.

  [ Nicolas Boulenguez ]
  * Design and implement the `built-using` and `static-built-using`
    feature based on `dh-builtusing`.

  [ Niels Thykier ]
  * debputy: Recognise `.org` as common upstream changelog extension.
    This is to match `dh_installchangelogs`.
  * Generated prerm: Validate that `python3` works before calling
    `py3clean`. This is to match what `dh-python` does.

 -- Niels Thykier <niels@thykier.net>  Sun, 28 Dec 2025 12:07:00 +0000
